package io.accumulatenetwork.sdk.generated.apiv2;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.DataEntry;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.protocol.TxID;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("DataEntryQueryResponse")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class DataEntryQueryResponse implements Marshallable {
	private byte[] entryHash;
	private DataEntry entry;
	private TxID txId;
	private TxID causeTxId;

    //
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getEntryHash() {
	    return entryHash;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setEntryHash(final byte[] value) {
	    this.entryHash = value;
	}

	public DataEntryQueryResponse entryHash(final byte[] value) {
	    setEntryHash(value);
	    return this;
	}
	public DataEntryQueryResponse entryHash(final String value) {
		try {
			setEntryHash(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
	public DataEntry getEntry() {
	    return entry;
	}
	public void setEntry(final DataEntry value) {
	    this.entry = value;
	}

	public DataEntryQueryResponse entry(final DataEntry value) {
	    setEntry(value);
	    return this;
	}
	public TxID getTxId() {
	    return txId;
	}
	public void setTxId(final TxID value) {
	    this.txId = value;
	}

	public DataEntryQueryResponse txId(final TxID value) {
	    setTxId(value);
	    return this;
	}
	public TxID getCauseTxId() {
	    return causeTxId;
	}
	public void setCauseTxId(final TxID value) {
	    this.causeTxId = value;
	}

	public DataEntryQueryResponse causeTxId(final TxID value) {
	    setCauseTxId(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.entryHash == null || this.entryHash.length == 0)) {
            marshaller.writeHash(1, this.entryHash);
        }
        if (!(this.entry == null)) {
            marshaller.writeValue(2, entry);
        }
        if (!(this.txId == null)) {
            marshaller.writeTxid(3, this.txId);
        }
        if (!(this.causeTxId == null)) {
            marshaller.writeTxid(4, this.causeTxId);
        }
        return marshaller.array();
    }
}
